searchData={"items":[{"type":"module","doc":"Gettext stub,\nreferenced in AshAuthentication.Phoenix.Test.Router","title":"AshAuthentication.Phoenix.Test.Gettext","ref":"AshAuthentication.Phoenix.Test.Gettext.html"},{"type":"function","doc":"","title":"AshAuthentication.Phoenix.Test.Gettext.handle_missing_bindings/2","ref":"AshAuthentication.Phoenix.Test.Gettext.html#handle_missing_bindings/2"},{"type":"function","doc":"","title":"AshAuthentication.Phoenix.Test.Gettext.handle_missing_plural_translation/7","ref":"AshAuthentication.Phoenix.Test.Gettext.html#handle_missing_plural_translation/7"},{"type":"function","doc":"","title":"AshAuthentication.Phoenix.Test.Gettext.translate_test/2","ref":"AshAuthentication.Phoenix.Test.Gettext.html#translate_test/2"},{"type":"task","doc":"Prints all routes pertaining to AshAuthenticationPhoenix for the default or a given router.\n\nThis task can be called directly, accepting the same options as `mix phx.routes`, except for `--info`.\n\nAlternatively, you can modify your aliases task to run them back to back it.\n\n```elixir\naliases: [\"phx.routes\": [\"do\", \"phx.routes,\", \"ash_authentication.phoenix.routes\"]]\n```","title":"mix ash_authentication.phoenix.routes","ref":"Mix.Tasks.AshAuthentication.Phoenix.Routes.html"},{"type":"function","doc":"","title":"Mix.Tasks.AshAuthentication.Phoenix.Routes.get_url_info/2","ref":"Mix.Tasks.AshAuthentication.Phoenix.Routes.html#get_url_info/2"},{"type":"task","doc":"Installs AshAuthenticationPhoenix. Invoke with `mix igniter.install ash_authentication_phoenix`","title":"mix ash_authentication_phoenix.install","ref":"Mix.Tasks.AshAuthenticationPhoenix.Install.html"},{"type":"task","doc":"```bash\nmix igniter.install ash_authentication_phoenix\n```","title":"Example - mix ash_authentication_phoenix.install","ref":"Mix.Tasks.AshAuthenticationPhoenix.Install.html#module-example"},{"type":"task","doc":"* `--accounts` or `-a` - The domain that contains your resources. Defaults to `YourApp.Accounts`.\n* `--user` or `-u` - The resource that represents a user. Defaults to ` .User`.\n* `--token` or `-t` - The resource that represents a token. Defaults to ` .Token`.","title":"Options - mix ash_authentication_phoenix.install","ref":"Mix.Tasks.AshAuthenticationPhoenix.Install.html#module-options"},{"type":"function","doc":"","title":"Mix.Tasks.AshAuthenticationPhoenix.Install.igniter/2","ref":"Mix.Tasks.AshAuthenticationPhoenix.Install.html#igniter/2"},{"type":"module","doc":"Welcome to `AshAuthentication.Pheonix`.\n\nThe `ash_authentication_phoenix` package extends\n[`ash_authentication`](https://github.com/team-alembic/ash_authentication) by\nadding router helpers, plugs and behaviours that makes adding authentication\nto an existing Ash-based Phoenix application dead easy.","title":"AshAuthentication.Phoenix","ref":"AshAuthentication.Phoenix.html"},{"type":"module","doc":"Presuming that you already have [Phoenix](https://phoenixframework.org/),\n[Ash](https://ash-hq.org/) and\n[AshAuthentication](https://github.com/team-alembic/ash_authentication)\ninstalled and configured, start by adding plugs and routes to your router\nusing `AshAuthentication.Phoenix.Router` and customising your sign-in page as\nneeded.","title":"Where to start. - AshAuthentication.Phoenix","ref":"AshAuthentication.Phoenix.html#module-where-to-start"},{"type":"module","doc":"There are several methods of customisation available depending on the level of\ncontrol you would like:\n\n  1. Use the generic sign-in liveview -\n     `AshAuthentication.Phoenix.SignInLive`.\n  2. Apply overrides using `AshAuthentication.Phoenix.Overrides` to set your\n     own CSS classes for all components.\n  3. Build your own sign-in pages using the pre-defined components.\n  4. Build your own sign-in pages using the generated `auth` routes.","title":"Customisation - AshAuthentication.Phoenix","ref":"AshAuthentication.Phoenix.html#module-customisation"},{"type":"behaviour","doc":"The authentication controller generator.\n\nSince authentication often requires explicit HTTP requests to do things like\nset cookies or return Authorization headers, use this module to create an\n`AuthController` in your Phoenix application.","title":"AshAuthentication.Phoenix.Controller","ref":"AshAuthentication.Phoenix.Controller.html"},{"type":"behaviour","doc":"Handling the registration or authentication of a normal web-based user.\n\n```elixir\ndefmodule MyAppWeb.AuthController do\n  use MyAppWeb, :controller\n  use AshAuthentication.Phoenix.Controller\n\n  def success(conn, _activity, user, _token) do\n    conn\n    |> store_in_session(user)\n    |> assign(:current_user, user)\n    |> redirect(to: Routes.page_path(conn, :index))\n  end\n\n  def failure(conn, _activity, _reason) do\n    conn\n    |> put_status(401)\n    |> render(\"failure.html\")\n  end\n\n  def sign_out(conn, _params) do\n    conn\n    |> clear_session()\n    |> render(\"sign_out.html\")\n  end\nend\n```\n\nHandling registration or authentication of an API user.\n\n```elixir\ndefmodule MyAppWeb.ApiAuthController do\n  use MyAppWeb, :controller\n  use AshAuthentication.Phoenix.Controller\n  alias AshAuthentication.TokenRevocation\n\n  def success(conn, _activity, _user, token) do\n    conn\n    |> put_status(200)\n    |> json(%{\n      authentication: %{\n        status: :success,\n        bearer: token}\n    })\n  end\n\n  def failure(conn, _activity, _reason) do\n    conn\n    |> put_status(401)\n    |> json(%{\n      authentication: %{\n        status: :failed\n      }\n    })\n  end\n\n  def sign_out(conn, _params) do\n    conn\n    |> revoke_bearer_tokens()\n    |> json(%{\n      status: :ok\n    })\n  end\nend\n```","title":"Example - AshAuthentication.Phoenix.Controller","ref":"AshAuthentication.Phoenix.Controller.html#module-example"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Controller.activity/0","ref":"AshAuthentication.Phoenix.Controller.html#t:activity/0"},{"type":"callback","doc":"Called when authentication fails.","title":"AshAuthentication.Phoenix.Controller.failure/3","ref":"AshAuthentication.Phoenix.Controller.html#c:failure/3"},{"type":"callback","doc":"Called when a request to sign out is received.","title":"AshAuthentication.Phoenix.Controller.sign_out/2","ref":"AshAuthentication.Phoenix.Controller.html#c:sign_out/2"},{"type":"callback","doc":"Called when authentication (or registration, depending on the provider) has been successful.","title":"AshAuthentication.Phoenix.Controller.success/4","ref":"AshAuthentication.Phoenix.Controller.html#c:success/4"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Controller.t/0","ref":"AshAuthentication.Phoenix.Controller.html#t:t/0"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Controller.token/0","ref":"AshAuthentication.Phoenix.Controller.html#t:token/0"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Controller.user/0","ref":"AshAuthentication.Phoenix.Controller.html#t:user/0"},{"type":"module","doc":"Ensures that any loaded users which are present in a conn's assigns are also\npresent in a live view socket's assigns.\n\nTypical usage is via the `ash_authentication_live_session/2` macro, but can also\nmanually called like so:\n\n```elixir\nscope \"/\", ExampleWeb do\n  pipe_through(:browser)\n\n  live_session :authenticated, on_mount: LiveSession, session: {LiveSession, :generate_session, []} do\n    live \"/\", ExampleLive\n  end\nend\n```","title":"AshAuthentication.Phoenix.LiveSession","ref":"AshAuthentication.Phoenix.LiveSession.html"},{"type":"macro","doc":"Generate a live session wherein all subject assigns are copied from the conn\ninto the socket.\n\nOptions:\n  * `:otp_app` - Set the otp app in which to search for authenticated resources.\n\nAll other options are passed through to `live_session`, but with session and on_mount hooks\nadded to set assigns for authenticated resources. Unlike `live_session`, this supports\nmultiple MFAs provided for the `session` option. The produced sessions will be merged.","title":"AshAuthentication.Phoenix.LiveSession.ash_authentication_live_session/3","ref":"AshAuthentication.Phoenix.LiveSession.html#ash_authentication_live_session/3"},{"type":"function","doc":"Assigns all subjects from their equivalent sessions, if they are not already assigned.\n\nThis exists to power nested liveviews, which have the session available but\ndo not automatically inherit any assigns.\n\nThis does verify the token and confirm that it is not expired, but it\nbypasses the check for the token's presence in the token resource, even if\nyou have configured AshAuthentication to\n`require_token_presence_for_authentication?`. This is because nested live views\ndo not need to check *again* for this, as the `:load_from_session` plug already\ndoes this.","title":"AshAuthentication.Phoenix.LiveSession.assign_new_resources/3","ref":"AshAuthentication.Phoenix.LiveSession.html#assign_new_resources/3"},{"type":"function","doc":"Supplements the session with any `current_X` assigns which are authenticated\nresource records from the conn.","title":"AshAuthentication.Phoenix.LiveSession.generate_session/3","ref":"AshAuthentication.Phoenix.LiveSession.html#generate_session/3"},{"type":"function","doc":"Inspects the incoming session for any subject_name -> subject values and loads\nthem into the socket's assigns.\n\nFor example a session containing `{\"user\",\n\"user?id=aa6c179c-ee75-4d49-8796-528c2981b396\"}` becomes an assign called\n`current_user` with the loaded user as the value.","title":"AshAuthentication.Phoenix.LiveSession.on_mount/4","ref":"AshAuthentication.Phoenix.LiveSession.html#on_mount/4"},{"type":"function","doc":"Get options that should be passed to `live_session`.\n\nThis is useful for integrating with other tools that require a custom `live_session`,\nlike `beacon_live_admin`. For example:\n\n```elixir\nbeacon_live_admin AshAuthentication.Phoenix.LiveSession.opts(...beacon_opts) do\n  ...\nend\n```","title":"AshAuthentication.Phoenix.LiveSession.opts/1","ref":"AshAuthentication.Phoenix.LiveSession.html#opts/1"},{"type":"module","doc":"Helper plugs mixed in to your router.\n\nWhen you `use AshAuthentication.Phoenix.Router` this module is included, so\nthat you can use these plugs in your pipelines.","title":"AshAuthentication.Phoenix.Plug","ref":"AshAuthentication.Phoenix.Plug.html"},{"type":"function","doc":"Attempt to retrieve actors from the `Authorization` header(s).\n\nA wrapper around `AshAuthentication.Plug.Helpers.retrieve_from_bearer/2` with\nthe `otp_app` as extracted from the endpoint.","title":"AshAuthentication.Phoenix.Plug.load_from_bearer/2","ref":"AshAuthentication.Phoenix.Plug.html#load_from_bearer/2"},{"type":"function","doc":"Attempt to retrieve all actors from the connections' session.\n\nA wrapper around `AshAuthentication.Plug.Helpers.retrieve_from_session/2`\nwith the `otp_app` as extracted from the endpoint.","title":"AshAuthentication.Phoenix.Plug.load_from_session/2","ref":"AshAuthentication.Phoenix.Plug.html#load_from_session/2"},{"type":"function","doc":"Revoke all token(s) in the `Authorization` header(s).\n\nA wrapper around `AshAuthentication.Plug.Helpers.revoke_bearer_tokens/2` with\nthe `otp_app` as extracted from the endpoint.","title":"AshAuthentication.Phoenix.Plug.revoke_bearer_tokens/2","ref":"AshAuthentication.Phoenix.Plug.html#revoke_bearer_tokens/2"},{"type":"function","doc":"Store the actor in the connections' session.","title":"AshAuthentication.Phoenix.Plug.store_in_session/2","ref":"AshAuthentication.Phoenix.Plug.html#store_in_session/2"},{"type":"module","doc":"Phoenix route generation for AshAuthentication.\n\nUsing this module imports the macros in this module and the plug functions\nfrom `AshAuthentication.Phoenix.Plug`.","title":"AshAuthentication.Phoenix.Router","ref":"AshAuthentication.Phoenix.Router.html"},{"type":"module","doc":"Adding authentication to your live-view router is very simple:\n\n```elixir\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n  use AshAuthentication.Phoenix.Router\n\n  pipeline :browser do\n    # ...\n    plug(:load_from_session)\n  end\n\n  pipeline :api do\n    # ...\n    plug(:load_from_bearer)\n  end\n\n  scope \"/\", MyAppWeb do\n    pipe_through :browser\n    sign_in_route auth_routes_prefix: \"/auth\"\n    sign_out_route AuthController\n    auth_routes_for MyApp.Accounts.User, to: AuthController\n    reset_route auth_routes_prefix: \"/auth\"\n  end\n```","title":"Usage - AshAuthentication.Phoenix.Router","ref":"AshAuthentication.Phoenix.Router.html#module-usage"},{"type":"type","doc":"Options that can be passed to `auth_routes_for`.","title":"AshAuthentication.Phoenix.Router.auth_route_options/0","ref":"AshAuthentication.Phoenix.Router.html#t:auth_route_options/0"},{"type":"macro","doc":"Generates the routes needed for the various strategies for a given\nAshAuthentication resource.\n\nThis matches *all* routes at the provided `path`, which defaults to `/auth`. This means that\nif you have any other routes that begin with `/auth`, you will need to make sure this\nappears after them.","title":"AshAuthentication.Phoenix.Router.auth_routes/3","ref":"AshAuthentication.Phoenix.Router.html#auth_routes/3"},{"type":"macro","doc":"If you are using route helpers anywhere in your application, typically looks like `Routes.auth_path/3`\nor `Helpers.auth_path/3` you will need to update them to use verified routes. To see what routes are\navailable to you, use `mix ash_authentication.phoenix.routes`.\n\nIf you are using any of the components provided by `AshAuthenticationPhoenix`, you will need to supply\nthem with the `auth_routes_prefix` assign, set to the `path` you provide here (set to `/auth` by default).\n\nYou also will need to set `auth_routes_prefix` on the `reset_route`, i.e `reset_route(auth_routes_prefix: \"/auth\")`","title":"Upgrading from `auth_routes_for/2` - AshAuthentication.Phoenix.Router.auth_routes/3","ref":"AshAuthentication.Phoenix.Router.html#auth_routes/3-upgrading-from-auth_routes_for-2"},{"type":"macro","doc":"* `path` - the path to mount auth routes at. Defaults to `/auth`. If changed, you will also want\n  to change the `auth_routes_prefix` option in `sign_in_route` to match.\n  routes.\n* `not_found_plug` - a plug to call if no route is found. By default, it renders a simple JSON\n  response with a 404 status code.\n* `as` - the alias to use for the generated scope. Defaults to `:auth`.","title":"Options - AshAuthentication.Phoenix.Router.auth_routes/3","ref":"AshAuthentication.Phoenix.Router.html#auth_routes/3-options"},{"type":"macro","doc":"Generates the routes needed for the various strategies for a given\nAshAuthentication resource.\n\nThis is required if you wish to use authentication.","title":"AshAuthentication.Phoenix.Router.auth_routes_for/2","ref":"AshAuthentication.Phoenix.Router.html#auth_routes_for/2"},{"type":"macro","doc":"* `to` - a module which implements the\n    `AshAuthentication.Phoenix.Controller` behaviour.  This is required.\n  * `path` - a string (starting with \"/\") wherein to mount the generated\n    routes.\n  * `scope_opts` - any options to pass to the generated scope.","title":"Options - AshAuthentication.Phoenix.Router.auth_routes_for/2","ref":"AshAuthentication.Phoenix.Router.html#auth_routes_for/2-options"},{"type":"macro","doc":"```elixir\nscope \"/\", DevWeb do\n  auth_routes_for(MyApp.Accounts.User,\n    to: AuthController,\n    path: \"/authentication\",\n    scope_opts: [host: \"auth.example.com\"]\n  )\nend\n```","title":"Example - AshAuthentication.Phoenix.Router.auth_routes_for/2","ref":"AshAuthentication.Phoenix.Router.html#auth_routes_for/2-example"},{"type":"macro","doc":"Generates a generic, white-label confirmation page using LiveView and the components in\n`AshAuthentication.Phoenix.Components`.\n\nThis is used when `require_interaction?` is set to `true` on a confirmation strategy.\n\nAvailable options are:\n\n  * `path` the path under which to mount the live-view. Defaults to\n    \"/ \".\n  * `token_as_route_param?` whether to use the token as a route parameter. i.e ` /:token`. Defaults to `true`.\n  * `live_view` the name of the live view to render. Defaults to\n    `AshAuthentication.Phoenix.ConfirmLive`.\n  * `as` which is passed to the generated `live` route. Defaults to `:auth`.\n  * `overrides` specify any override modules for customisation. See\n    `AshAuthentication.Phoenix.Overrides` for more information.\n  * `gettext_fn` as a `{module :: module, function :: atom}` tuple pointing to a\n    `(msgid :: String.t(), bindings :: keyword) :: String.t()` typed function that will be called to translate\n    each output text of the live view.\n  * `gettext_backend` as a `{module :: module, domain :: String.t()}` tuple pointing to a Gettext backend module\n    and specifying the Gettext domain. This is basically a convenience wrapper around `gettext_fn`.\n\nAll other options are passed to the generated `scope`.","title":"AshAuthentication.Phoenix.Router.confirm_route/3","ref":"AshAuthentication.Phoenix.Router.html#confirm_route/3"},{"type":"type","doc":"A sub-path if required.  Defaults to `/auth`.","title":"AshAuthentication.Phoenix.Router.path_option/0","ref":"AshAuthentication.Phoenix.Router.html#t:path_option/0"},{"type":"macro","doc":"Generates a generic, white-label password reset page using LiveView and the components in\n`AshAuthentication.Phoenix.Components`. This is the page that allows a user to actually change his password,\nafter requesting a reset token via the sign-in (`/reset`) route.\n\nAvailable options are:\n\n  * `path` the path under which to mount the live-view. Defaults to\n    `/password-reset`.\n  * `live_view` the name of the live view to render. Defaults to\n    `AshAuthentication.Phoenix.ResetLive`.\n  * `as` which is passed to the generated `live` route. Defaults to `:auth`.\n  * `overrides` specify any override modules for customisation. See\n    `AshAuthentication.Phoenix.Overrides` for more information.\n  * `gettext_fn` as a `{module :: module, function :: atom}` tuple pointing to a\n    `(msgid :: String.t(), bindings :: keyword) :: String.t()` typed function that will be called to translate\n    each output text of the live view.\n  * `gettext_backend` as a `{module :: module, domain :: String.t()}` tuple pointing to a Gettext backend module\n    and specifying the Gettext domain. This is basically a convenience wrapper around `gettext_fn`.\n\nAll other options are passed to the generated `scope`.","title":"AshAuthentication.Phoenix.Router.reset_route/1","ref":"AshAuthentication.Phoenix.Router.html#reset_route/1"},{"type":"type","doc":"Any options which should be passed to the generated scope.","title":"AshAuthentication.Phoenix.Router.scope_opts_option/0","ref":"AshAuthentication.Phoenix.Router.html#t:scope_opts_option/0"},{"type":"macro","doc":"Generates a generic, white-label sign-in page using LiveView and the\ncomponents in `AshAuthentication.Phoenix.Components`.\n\nThis is completely optional.\n\nAvailable options are:\n\n* `path` the path under which to mount the sign-in live-view. Defaults to `/sign-in` within the current router scope.\n* `auth_routes_prefix` if set, this will be used instead of route helpers when determining routes.\n  Allows disabling `helpers: true`.\n  If a tuple {:unscoped, path} is provided, the path prefix will not inherit the current route scope.\n* `register_path` - the path under which to mount the password strategy's registration live-view.\n   If not set, and registration is supported, registration will use a dynamic toggle and will not be routeable to.\n   If a tuple {:unscoped, path} is provided, the registration path will not inherit the current route scope.\n* `reset_path` - the path under which to mount the password strategy's password reset live-view, for a user to\n  request a reset token by email. If not set, and password reset is supported, password reset will use a\n  dynamic toggle and will not be routeable to. If a tuple {:unscoped, path} is provided, the reset path\n  will not inherit the current route scope.\n* `resources` - Which resources should have their sign in UIs rendered. Defaults to all resources\n  that use `AshAuthentication`.\n* `live_view` the name of the live view to render. Defaults to\n  `AshAuthentication.Phoenix.SignInLive`.\n* `auth_routes_prefix` the prefix to use for the auth routes. Defaults to `/auth`.\n* `as` which is used to prefix the generated `live_session` and `live` route name. Defaults to `:auth`.\n* `otp_app` the otp app or apps to find authentication resources in. Pulls from the socket by default.\n* `overrides` specify any override modules for customisation.  See\n  `AshAuthentication.Phoenix.Overrides` for more information.\n* `gettext_fn` as a `{module :: module, function :: atom}` tuple pointing to a\n  `(msgid :: String.t(), bindings :: keyword) :: String.t()` typed function that will be called to translate\n  each output text of the live view.\n* `gettext_backend` as a `{module :: module, domain :: String.t()}` tuple pointing to a Gettext backend module\n  and specifying the Gettext domain. This is basically a convenience wrapper around `gettext_fn`.\n\nAll other options are passed to the generated `scope`.","title":"AshAuthentication.Phoenix.Router.sign_in_route/1","ref":"AshAuthentication.Phoenix.Router.html#sign_in_route/1"},{"type":"macro","doc":"Generates a sign-out route which points to the `sign_out` action in your auth\ncontroller.\n\nThis is optional, but you probably want it.","title":"AshAuthentication.Phoenix.Router.sign_out_route/3","ref":"AshAuthentication.Phoenix.Router.html#sign_out_route/3"},{"type":"type","doc":"The controller which will handle success and failure.","title":"AshAuthentication.Phoenix.Router.to_option/0","ref":"AshAuthentication.Phoenix.Router.html#t:to_option/0"},{"type":"module","doc":"Generates a sign-in button for Apple.","title":"AshAuthentication.Phoenix.Components.Apple","ref":"AshAuthentication.Phoenix.Components.Apple.html"},{"type":"module","doc":"This is the top-most strategy-specific component, nested below\n`AshAuthentication.Phoenix.Components.SignIn`.","title":"Component hierarchy - AshAuthentication.Phoenix.Components.Apple","ref":"AshAuthentication.Phoenix.Components.Apple.html#module-component-hierarchy"},{"type":"module","doc":"* `strategy` - The strategy configuration as per\n    `AshAuthentication.Info.strategy/2`.  Required.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.Apple","ref":"AshAuthentication.Phoenix.Components.Apple.html#module-props"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:root_class` - CSS classes for the root `div` element.\n  * `:link_class` - CSS classes for the `a` element.\n  * `:icon_class` - CSS classes for the icon SVG.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.Components.Apple","ref":"AshAuthentication.Phoenix.Components.Apple.html#module-overrides"},{"type":"function","doc":"","title":"AshAuthentication.Phoenix.Components.Apple.icon/1","ref":"AshAuthentication.Phoenix.Components.Apple.html#icon/1"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Components.Apple.props/0","ref":"AshAuthentication.Phoenix.Components.Apple.html#t:props/0"},{"type":"module","doc":"Renders a very simple banner at the top of the sign-in component.\n\nCan show either an image or some text, depending on the provided overrides.","title":"AshAuthentication.Phoenix.Components.Banner","ref":"AshAuthentication.Phoenix.Components.Banner.html"},{"type":"module","doc":"* `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.Banner","ref":"AshAuthentication.Phoenix.Components.Banner.html#module-props"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:text` - Banner text. Set to `nil` to disable.\n  * `:root_class` - CSS class for the root `div` element.\n  * `:href_class` - CSS class for the `a` tag.\n  * `:href_url` - A URL for the banner image to link to. Set to `nil` to disable.\n  * `:image_class` - CSS class for the `img` tag.\n  * `:dark_image_class` - Css class for the `img` tag in dark mode.\n  * `:image_url` - A URL for the `img` `src` attribute. Set to `nil` to disable.\n  * `:dark_image_url` - A URL for the `img` `src` attribute in dark mode. Set to `nil` to disable.\n  * `:text_class` - CSS class for the text `div`.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.Components.Banner","ref":"AshAuthentication.Phoenix.Components.Banner.html#module-overrides"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Components.Banner.props/0","ref":"AshAuthentication.Phoenix.Components.Banner.html#t:props/0"},{"type":"module","doc":"Renders a confirmation button.","title":"AshAuthentication.Phoenix.Components.Confirm","ref":"AshAuthentication.Phoenix.Components.Confirm.html"},{"type":"module","doc":"Children:\n  * `AshAuthentication.Phoenix.Components.ConfirmForm.confirm_form/1`","title":"Component hierarchy - AshAuthentication.Phoenix.Components.Confirm","ref":"AshAuthentication.Phoenix.Components.Confirm.html#module-component-hierarchy"},{"type":"module","doc":"* `token` - The confirmation token.\n  * `resource` - The resource to confirm.\n  * `strategy` - The strategy to confirm.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.\n  * `otp_app` - The otp app to look for authenticated resources in","title":"Props - AshAuthentication.Phoenix.Components.Confirm","ref":"AshAuthentication.Phoenix.Components.Confirm.html#module-props"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:root_class` - CSS class for the root `div` element.\n  * `:strategy_class` - CSS class for a `div` surrounding each strategy component.\n  * `:show_banner` - Whether or not to show the banner.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.Components.Confirm","ref":"AshAuthentication.Phoenix.Components.Confirm.html#module-overrides"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Components.Confirm.props/0","ref":"AshAuthentication.Phoenix.Components.Confirm.html#t:props/0"},{"type":"module","doc":"Generates a default confirmation form.","title":"AshAuthentication.Phoenix.Components.Confirm.Form","ref":"AshAuthentication.Phoenix.Components.Confirm.Form.html"},{"type":"module","doc":"This is a child of `AshAuthentication.Phoenix.Components.Confirm`.\n\nChildren:\n\n  * `AshAuthentication.Phoenix.Components.Confirm.Input.submit/1`","title":"Component hierarchy - AshAuthentication.Phoenix.Components.Confirm.Form","ref":"AshAuthentication.Phoenix.Components.Confirm.Form.html#module-component-hierarchy"},{"type":"module","doc":"* `token` - The confirmation token.\n  * `socket` - Phoenix LiveView socket.  This is needed to be able to retrieve\n    the correct CSS configuration. Required.\n  * `strategy` - The configuration map as per\n    `AshAuthentication.Info.strategy/2`. Required.\n  * `label` - The text to show in the submit label. Generated from the\n    strategy name (via `Phoenix.Naming.humanize/1`) if not\n    supplied. Set to `false` to disable.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.Confirm.Form","ref":"AshAuthentication.Phoenix.Components.Confirm.Form.html#module-props"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:root_class` - CSS class for the root `div` element.\n  * `:label_class` - CSS class for the `h2` element.\n  * `:form_class` - CSS class for the `form` element.\n  * `:disable_button_text` - Text for the submit button when the request is happening.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.Components.Confirm.Form","ref":"AshAuthentication.Phoenix.Components.Confirm.Form.html#module-overrides"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Components.Confirm.Form.props/0","ref":"AshAuthentication.Phoenix.Components.Confirm.Form.html#t:props/0"},{"type":"module","doc":"Function components for dealing with form input during password\nauthentication.","title":"AshAuthentication.Phoenix.Components.Confirm.Input","ref":"AshAuthentication.Phoenix.Components.Confirm.Input.html"},{"type":"module","doc":"These function components are consumed by\n`AshAuthentication.Phoenix.Components.Password.SignInForm`,\n`AshAuthentication.Phoenix.Components.Password.RegisterForm` and\n`AshAuthentication.Phoenix.Components.ResetForm`.","title":"Component hierarchy - AshAuthentication.Phoenix.Components.Confirm.Input","ref":"AshAuthentication.Phoenix.Components.Confirm.Input.html#module-component-hierarchy"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:submit_label` - A function that takes the strategy and returns text for the confirm button, or a string.\n  * `:submit_class` - CSS class for the form submit `input` element.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.Components.Confirm.Input","ref":"AshAuthentication.Phoenix.Components.Confirm.Input.html#module-overrides"},{"type":"function","doc":"Generate an form submit button.","title":"AshAuthentication.Phoenix.Components.Confirm.Input.submit/1","ref":"AshAuthentication.Phoenix.Components.Confirm.Input.html#submit/1"},{"type":"function","doc":"* `socket` - Phoenix LiveView socket.  This is needed to be able to retrieve\n    the correct CSS configuration.  Required.\n  * `strategy` - The configuration map as per\n    `AshAuthentication.authenticated_resources/1`.  Required.\n  * `form` - An `AshPhoenix.Form`.  Required.\n  * `submit_label` - The text to show in the submit label.  Generated from the\n    configured action name (via `Phoenix.Naming.humanize/1`) if not supplied.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.Confirm.Input.submit/1","ref":"AshAuthentication.Phoenix.Components.Confirm.Input.html#submit/1-props"},{"type":"module","doc":"Helpers which are commonly needed inside the various components.","title":"AshAuthentication.Phoenix.Components.Helpers","ref":"AshAuthentication.Phoenix.Components.Helpers.html"},{"type":"function","doc":"","title":"AshAuthentication.Phoenix.Components.Helpers.auth_path/6","ref":"AshAuthentication.Phoenix.Components.Helpers.html#auth_path/6"},{"type":"function","doc":"The LiveView `Socket` contains a reference to the Phoenix endpoint, and from\nthere we can extract the `otp_app` of the current request.\n\nThis is pulled from `assigns[:otp_app]`, or inferred\nfrom the socket if that is not set.","title":"AshAuthentication.Phoenix.Components.Helpers.otp_app_from_socket/1","ref":"AshAuthentication.Phoenix.Components.Helpers.html#otp_app_from_socket/1"},{"type":"function","doc":"The LiveView `Socket` contains a refererence to the Phoenix router, and from\nthere we can generate the name of the route helpers module.","title":"AshAuthentication.Phoenix.Components.Helpers.route_helpers/1","ref":"AshAuthentication.Phoenix.Components.Helpers.html#route_helpers/1"},{"type":"module","doc":"A horizontal rule with text.\n\nThis component is pretty tailwind-specific, but I (@jimsynz) really wanted a\ncertain look.  If you think I'm wrong then please let me know.","title":"AshAuthentication.Phoenix.Components.HorizontalRule","ref":"AshAuthentication.Phoenix.Components.HorizontalRule.html"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:text` - Text to display in front of the horizontal rule.\n  * `:root_class` - CSS class for the root `div` element.\n  * `:hr_outer_class` - CSS class for the outer `div` element of the horizontal rule.\n  * `:hr_inner_class` - CSS class for the inner `div` element of the horizontal rule.\n  * `:text_outer_class` - CSS class for the outer `div` element of the text area.\n  * `:text_inner_class` - CSS class for the inner `div` element of the text area.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.Components.HorizontalRule","ref":"AshAuthentication.Phoenix.Components.HorizontalRule.html#module-overrides"},{"type":"module","doc":"* `overrides` - A list of override modules.","title":"Props - AshAuthentication.Phoenix.Components.HorizontalRule","ref":"AshAuthentication.Phoenix.Components.HorizontalRule.html#module-props"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Components.HorizontalRule.props/0","ref":"AshAuthentication.Phoenix.Components.HorizontalRule.html#t:props/0"},{"type":"module","doc":"Generates a sign-in for for a resource using the \"Magic link\" strategy.","title":"AshAuthentication.Phoenix.Components.MagicLink","ref":"AshAuthentication.Phoenix.Components.MagicLink.html"},{"type":"module","doc":"This is the top-most strategy-specific component, nested below\n`AshAuthentication.Phoenix.Components.SignIn`.\n\nChildren:\n\n  * `AshAuthentication.Phoenix.Components.Password.Input.identity_field/1`\n  * `AshAuthentication.Phoenix.Components.Password.Input.submit/1`","title":"Component hierarchy - AshAuthentication.Phoenix.Components.MagicLink","ref":"AshAuthentication.Phoenix.Components.MagicLink.html#module-component-hierarchy"},{"type":"module","doc":"* `strategy` - the strategy configuration as per\n    `AshAuthentication.Info.strategy/2`.  Required.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.MagicLink","ref":"AshAuthentication.Phoenix.Components.MagicLink.html#module-props"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:root_class` - CSS class for the root `div` element.\n  * `:label_class` - CSS class for the `h2` element.\n  * `:form_class` - CSS class for the `form` element.\n  * `:disable_button_text` - Text for the submit button when the request is happening.\n  * `:request_flash_text` - Text for the flash message when a request is received.  Set to `nil` to disable.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.Components.MagicLink","ref":"AshAuthentication.Phoenix.Components.MagicLink.html#module-overrides"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Components.MagicLink.props/0","ref":"AshAuthentication.Phoenix.Components.MagicLink.html#t:props/0"},{"type":"module","doc":"Generates a sign-in button for OAuth2.","title":"AshAuthentication.Phoenix.Components.OAuth2","ref":"AshAuthentication.Phoenix.Components.OAuth2.html"},{"type":"module","doc":"This is the top-most strategy-specific component, nested below\n`AshAuthentication.Phoenix.Components.SignIn`.","title":"Component hierarchy - AshAuthentication.Phoenix.Components.OAuth2","ref":"AshAuthentication.Phoenix.Components.OAuth2.html#module-component-hierarchy"},{"type":"module","doc":"* `strategy` - The strategy configuration as per\n    `AshAuthentication.Info.strategy/2`.  Required.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.OAuth2","ref":"AshAuthentication.Phoenix.Components.OAuth2.html#module-props"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:root_class` - CSS classes for the root `div` element.\n  * `:link_class` - CSS classes for the `a` element.\n  * `:icon_class` - CSS classes for the icon SVG.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.Components.OAuth2","ref":"AshAuthentication.Phoenix.Components.OAuth2.html#module-overrides"},{"type":"function","doc":"","title":"AshAuthentication.Phoenix.Components.OAuth2.icon/1","ref":"AshAuthentication.Phoenix.Components.OAuth2.html#icon/1"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Components.OAuth2.props/0","ref":"AshAuthentication.Phoenix.Components.OAuth2.html#t:props/0"},{"type":"module","doc":"Generates sign in, registration and reset forms for a resource.","title":"AshAuthentication.Phoenix.Components.Password","ref":"AshAuthentication.Phoenix.Components.Password.html"},{"type":"module","doc":"This is the top-most strategy-specific component, nested below\n`AshAuthentication.Phoenix.Components.SignIn`.\n\nChildren:\n\n  * `AshAuthentication.Phoenix.Components.Password.SignInForm`\n  * `AshAuthentication.Phoenix.Components.Password.RegisterForm`\n  * `AshAuthentication.Phoenix.Components.Password.ResetForm`","title":"Component hierarchy - AshAuthentication.Phoenix.Components.Password","ref":"AshAuthentication.Phoenix.Components.Password.html#module-component-hierarchy"},{"type":"module","doc":"* `strategy` - The strategy configuration as per\n    `AshAuthentication.Info.strategy/2`.  Required.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.Password","ref":"AshAuthentication.Phoenix.Components.Password.html#module-props"},{"type":"module","doc":"* `sign_in_extra` - rendered inside the sign-in form with the form passed as\n    a slot argument.\n  * `register_extra` - rendered inside the registration form with the form\n    passed as a slot argument.\n  * `reset_extra` - rendered inside the reset form with the form passed as a\n    slot argument.\n  * `path` - used as the base for links to other pages.\n  * `reset_path` - the path to use for reset links.\n  * `register_path` - the path to use for register links.\n\n```heex\n<.live_component\n  module={AshAuthentication.Phoenix.Components.Password}\n  strategy={AshAuthentication.Info.strategy!(Example.User, :password)}\n  id=\"user-with-password\"\n  socket={@socket}\n  overrides={[AshAuthentication.Phoenix.Overrides.Default]}>\n\n  <:sign_in_extra :let={form}>\n    <.input field={form[:capcha]} />\n  </:sign_in_extra>\n\n  <:register_extra :let={form}>\n    <.input field={form[:name]} />\n  </:register_extra>\n\n  <:reset_extra :let={form}>\n    <.input field={form[:capcha]} />\n  </:reset_extra>\n</.live_component>\n```","title":"Slots - AshAuthentication.Phoenix.Components.Password","ref":"AshAuthentication.Phoenix.Components.Password.html#module-slots"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:root_class` - CSS class for the root `div` element.\n  * `:interstitial_class` - CSS class for the `div` element between the form and the button.\n  * `:toggler_class` - CSS class for the toggler `a` element.\n  * `:sign_in_toggle_text` - Toggle text to display when the sign in form is not showing (or `nil` to disable).\n  * `:register_toggle_text` - Toggle text to display when the register form is not showing (or `nil` to disable).\n  * `:reset_toggle_text` - Toggle text to display when the reset form is not showing (or `nil` to disable).\n  * `:show_first` - The form to show on first load.  Either `:sign_in` or `:register`. Only relevant if paths aren't set for them in the router.\n  * `:hide_class` - CSS class to apply to hide an element.\n  * `:slot_class` - CSS class for the `div` surrounding the slot.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.Components.Password","ref":"AshAuthentication.Phoenix.Components.Password.html#module-overrides"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Components.Password.props/0","ref":"AshAuthentication.Phoenix.Components.Password.html#t:props/0"},{"type":"module","doc":"Function components for dealing with form input during password\nauthentication.","title":"AshAuthentication.Phoenix.Components.Password.Input","ref":"AshAuthentication.Phoenix.Components.Password.Input.html"},{"type":"module","doc":"These function components are consumed by\n`AshAuthentication.Phoenix.Components.Password.SignInForm`,\n`AshAuthentication.Phoenix.Components.Password.RegisterForm` and\n`AshAuthentication.Phoenix.Components.ResetForm`.","title":"Component hierarchy - AshAuthentication.Phoenix.Components.Password.Input","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#module-component-hierarchy"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:label_class` - CSS class for `label` elements.\n  * `:submit_class` - CSS class for the form submit `input` element.\n  * `:field_class` - CSS class for `div` elements surrounding the fields.\n  * `:input_class` - CSS class for text/password `input` elements.\n  * `:input_class_with_error` - CSS class for text/password `input` elements when there is a validation error.\n  * `:password_input_label` - Label for password field.\n  * `:password_confirmation_input_label` - Label for password confirmation field.\n  * `:identity_input_label` - Label for identity field.\n  * `:identity_input_placeholder` - Placeholder for identity field.\n  * `:error_ul` - CSS class for the `ul` element on error lists.\n  * `:error_li` - CSS class for the `li` elements on error lists.\n  * `:input_debounce` - Number of milliseconds to debounce input by (or `nil` to disable).\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.Components.Password.Input","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#module-overrides"},{"type":"function","doc":"Generate a list of errors for a field (if there are any).","title":"AshAuthentication.Phoenix.Components.Password.Input.error/1","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#error/1"},{"type":"function","doc":"* `socket` - Phoenix LiveView socket.  This is needed to be able to retrieve\n    the correct CSS configuration.  Required.\n  * `form` - An `AshPhoenix.Form`.  Required.\n  * `field` - The field for which to retrieve the errors.  Required.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.Password.Input.error/1","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#error/1-props"},{"type":"function","doc":"Generate a form field for the configured identity field.","title":"AshAuthentication.Phoenix.Components.Password.Input.identity_field/1","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#identity_field/1"},{"type":"function","doc":"* `socket` - Phoenix LiveView socket.\n    This is needed to be able to retrieve the correct CSS configuration.\n    Required.\n  * `strategy` - The configuration map as per\n    `AshAuthentication.authenticated_resources/1`.\n    Required.\n  * `form` - An `AshPhoenix.Form`.\n    Required.\n  * `input_type` - Either `:text` or `:email`.\n    If not set it will try and guess based on the name of the identity field.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.Password.Input.identity_field/1","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#identity_field/1-props"},{"type":"function","doc":"Generate a form field for the configured password confirmation entry field.","title":"AshAuthentication.Phoenix.Components.Password.Input.password_confirmation_field/1","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#password_confirmation_field/1"},{"type":"function","doc":"* `socket` - Phoenix LiveView socket.  This is needed to be able to retrieve\n    the correct CSS configuration.  Required.\n  * `strategy` - The configuration map as per\n    `AshAuthentication.authenticated_resources/1`.  Required.\n  * `form` - An `AshPhoenix.Form`.  Required.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.Password.Input.password_confirmation_field/1","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#password_confirmation_field/1-props"},{"type":"function","doc":"Generate a form field for the configured password entry field.","title":"AshAuthentication.Phoenix.Components.Password.Input.password_field/1","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#password_field/1"},{"type":"function","doc":"* `socket` - Phoenix LiveView socket.  This is needed to be able to retrieve\n    the correct CSS configuration.  Required.\n  * `strategy` - The configuration map as per\n    `AshAuthentication.authenticated_resources/1`.  Required.\n  * `form` - An `AshPhoenix.Form`.  Required.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.Password.Input.password_field/1","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#password_field/1-props"},{"type":"function","doc":"Generate an form submit button.","title":"AshAuthentication.Phoenix.Components.Password.Input.submit/1","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#submit/1"},{"type":"function","doc":"* `socket` - Phoenix LiveView socket.  This is needed to be able to retrieve\n    the correct CSS configuration.  Required.\n  * `strategy` - The configuration map as per\n    `AshAuthentication.authenticated_resources/1`.  Required.\n  * `form` - An `AshPhoenix.Form`.  Required.\n  * `action` - Either `:sign_in`, `:register`, `:request_reset` or `:reset`.  Required.\n  * `label` - The text to show in the submit label.  Generated from the\n    configured action name (via `Phoenix.Naming.humanize/1`) if not supplied.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.Password.Input.submit/1","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#submit/1-props"},{"type":"module","doc":"Generates a default registration form.","title":"AshAuthentication.Phoenix.Components.Password.RegisterForm","ref":"AshAuthentication.Phoenix.Components.Password.RegisterForm.html"},{"type":"module","doc":"This is a child of `AshAuthentication.Phoenix.Components.Password`.\n\nChildren:\n\n  * `AshAuthentication.Phoenix.Components.Password.Input.identity_field/1`\n  * `AshAuthentication.Phoenix.Components.Password.Input.password_field/1`\n  * `AshAuthentication.Phoenix.Components.Password.Input.password_confirmation_field/1`\n  * `AshAuthentication.Phoenix.Components.Password.Input.submit/1`","title":"Component hierarchy - AshAuthentication.Phoenix.Components.Password.RegisterForm","ref":"AshAuthentication.Phoenix.Components.Password.RegisterForm.html#module-component-hierarchy"},{"type":"module","doc":"* `strategy` - The strategy configuration as per\n    `AshAuthentication.Info.strategy/2`.  Required.\n  * `socket` - Needed to infer the otp-app from the Phoenix endpoint.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.Password.RegisterForm","ref":"AshAuthentication.Phoenix.Components.Password.RegisterForm.html#module-props"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:root_class` - CSS class for the root `div` element.\n  * `:label_class` - CSS class for the `h2` element.\n  * `:form_class` - CSS class for the `form` element.\n  * `:disable_button_text` - Text for the submit button when the request is happening.\n  * `:button_text` - Text for the submit button.\n  * `:slot_class` - CSS class for the `div` surrounding the slot.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.Components.Password.RegisterForm","ref":"AshAuthentication.Phoenix.Components.Password.RegisterForm.html#module-overrides"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Components.Password.RegisterForm.props/0","ref":"AshAuthentication.Phoenix.Components.Password.RegisterForm.html#t:props/0"},{"type":"module","doc":"Generates a default password reset form.","title":"AshAuthentication.Phoenix.Components.Password.ResetForm","ref":"AshAuthentication.Phoenix.Components.Password.ResetForm.html"},{"type":"module","doc":"This is a child of `AshAuthentication.Phoenix.Components.Password`.\n\nChildren:\n\n  * `AshAuthentication.Phoenix.Components.Password.Input.identity_field/1`\n  * `AshAuthentication.Phoenix.Components.Password.Input.submit/1`","title":"Component hierarchy - AshAuthentication.Phoenix.Components.Password.ResetForm","ref":"AshAuthentication.Phoenix.Components.Password.ResetForm.html#module-component-hierarchy"},{"type":"module","doc":"* `strategy` - The configuration map as per\n    `AshAuthentication.Info.strategy/2`. Required.\n  * `label` - The text to show in the submit label.  Generated from the\n    configured action name (via `Phoenix.Naming.humanize/1`) if not supplied.\n    Set to `false` to disable.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.Password.ResetForm","ref":"AshAuthentication.Phoenix.Components.Password.ResetForm.html#module-props"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:root_class` - CSS class for the root `div` element.\n  * `:label_class` - CSS class for the `h2` element.\n  * `:form_class` - CSS class for the `form` element.\n  * `:disable_button_text` - Text for the submit button when the request is happening.\n  * `:button_text` - Tex for the submit button.\n  * `:slot_class` - CSS class for the `div` surrounding the slot.\n  * `:reset_flash_text` - Text for the flash message when a request is received.  Set to `nil` to disable.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.Components.Password.ResetForm","ref":"AshAuthentication.Phoenix.Components.Password.ResetForm.html#module-overrides"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Components.Password.ResetForm.props/0","ref":"AshAuthentication.Phoenix.Components.Password.ResetForm.html#t:props/0"},{"type":"module","doc":"Generates a default sign in form.","title":"AshAuthentication.Phoenix.Components.Password.SignInForm","ref":"AshAuthentication.Phoenix.Components.Password.SignInForm.html"},{"type":"module","doc":"This is a child of `AshAuthentication.Phoenix.Components.Password`.\n\nChildren:\n\n  * `AshAuthentication.Phoenix.Components.Password.Input.identity_field/1`\n  * `AshAuthentication.Phoenix.Components.Password.Input.password_field/1`\n  * `AshAuthentication.Phoenix.Components.Password.Input.submit/1`","title":"Component hierarchy - AshAuthentication.Phoenix.Components.Password.SignInForm","ref":"AshAuthentication.Phoenix.Components.Password.SignInForm.html#module-component-hierarchy"},{"type":"module","doc":"* `strategy` - The configuration map as per\n    `AshAuthentication.Info.strategy/2`. Required.\n  * `label` - The text to show in the submit label. Generated from the\n    configured action name (via `Phoenix.Naming.humanize/1`) if not supplied.\n    Set to `false` to disable.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.Password.SignInForm","ref":"AshAuthentication.Phoenix.Components.Password.SignInForm.html#module-props"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:root_class` - CSS class for the root `div` element.\n  * `:label_class` - CSS class for the `h2` element.\n  * `:form_class` - CSS class for the `form` element.\n  * `:disable_button_text` - Text for the submit button when the request is happening.\n  * `:button_text` - Text for the submit button.\n  * `:slot_class` - CSS class for the `div` surrounding the slot.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.Components.Password.SignInForm","ref":"AshAuthentication.Phoenix.Components.Password.SignInForm.html#module-overrides"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Components.Password.SignInForm.props/0","ref":"AshAuthentication.Phoenix.Components.Password.SignInForm.html#t:props/0"},{"type":"module","doc":"Renders a password-reset form.","title":"AshAuthentication.Phoenix.Components.Reset","ref":"AshAuthentication.Phoenix.Components.Reset.html"},{"type":"module","doc":"Children:\n\n  * `AshAuthentication.Phoenix.Components.Password.Input.password_field/1`\n  * `AshAuthentication.Phoenix.Components.Password.Input.password_confirmation_field/1`\n  * `AshAuthentication.Phoenix.Components.Password.Input.submit/1`","title":"Component hierarchy - AshAuthentication.Phoenix.Components.Reset","ref":"AshAuthentication.Phoenix.Components.Reset.html#module-component-hierarchy"},{"type":"module","doc":"* `token` - The reset token.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.\n  * `otp_app` - The otp app to look for authenticated resources in","title":"Props - AshAuthentication.Phoenix.Components.Reset","ref":"AshAuthentication.Phoenix.Components.Reset.html#module-props"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:root_class` - CSS class for the root `div` element.\n  * `:strategy_class` - CSS class for a `div` surrounding each strategy component.\n  * `:show_banner` - Whether or not to show the banner.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.Components.Reset","ref":"AshAuthentication.Phoenix.Components.Reset.html#module-overrides"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Components.Reset.props/0","ref":"AshAuthentication.Phoenix.Components.Reset.html#t:props/0"},{"type":"module","doc":"Generates a default password reset form.","title":"AshAuthentication.Phoenix.Components.Reset.Form","ref":"AshAuthentication.Phoenix.Components.Reset.Form.html"},{"type":"module","doc":"This is a child of `AshAuthentication.Phoenix.Components.Reset`.\n\nChildren:\n\n  * `AshAuthentication.Phoenix.Components.Password.Input.identity_field/1`\n  * `AshAuthentication.Phoenix.Components.Password.Input.password_field/1`\n  * `AshAuthentication.Phoenix.Components.Password.Input.submit/1`\n  * `AshAuthentication.Phoenix.Components.Password.Input.error/1`","title":"Component hierarchy - AshAuthentication.Phoenix.Components.Reset.Form","ref":"AshAuthentication.Phoenix.Components.Reset.Form.html#module-component-hierarchy"},{"type":"module","doc":"* `token` - The reset token.\n  * `socket` - Phoenix LiveView socket.  This is needed to be able to retrieve\n    the correct CSS configuration. Required.\n  * `strategy` - The configuration map as per\n    `AshAuthentication.Info.strategy/2`. Required.\n  * `label` - The text to show in the submit label. Generated from the\n    configured action name (via `Phoenix.Naming.humanize/1`) if not\n    supplied. Set to `false` to disable.\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.Reset.Form","ref":"AshAuthentication.Phoenix.Components.Reset.Form.html#module-props"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:root_class` - CSS class for the root `div` element.\n  * `:label_class` - CSS class for the `h2` element.\n  * `:form_class` - CSS class for the `form` element.\n  * `:disable_button_text` - Text for the submit button when the request is happening.\n  * `:spacer_class` - CSS classes for space between the password input and submit elements.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.Components.Reset.Form","ref":"AshAuthentication.Phoenix.Components.Reset.Form.html#module-overrides"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Components.Reset.Form.props/0","ref":"AshAuthentication.Phoenix.Components.Reset.Form.html#t:props/0"},{"type":"module","doc":"Renders sign in mark-up for an authenticated resource.\n\nThis means that it will render sign-in UI for all of the authentication\nstrategies for a resource.\n\nFor each strategy configured on the resource a component name is inferred\n(e.g. `AshAuthentication.Strategy.Password` becomes\n`AshAuthentication.Phoenix.Components.Password`) and is rendered into the\noutput.","title":"AshAuthentication.Phoenix.Components.SignIn","ref":"AshAuthentication.Phoenix.Components.SignIn.html"},{"type":"module","doc":"This is the top-most authentication component.\n\nChildren:\n\n  * `AshAuthentication.Phoenix.Components.Password`.\n  * `AshAuthentication.Phoenix.Components.OAuth2`.","title":"Component hierarchy - AshAuthentication.Phoenix.Components.SignIn","ref":"AshAuthentication.Phoenix.Components.SignIn.html#module-component-hierarchy"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:root_class` - CSS class for the root `div` element.\n  * `:strategy_class` - CSS class for a `div` surrounding each strategy component.\n  * `:show_banner` - Whether or not to show the banner.\n  * `:authentication_error_container_class` - CSS class for the container for the text of the authentication error.\n  * `:authentication_error_text_class` - CSS class for the authentication error text.\n  * `:strategy_display_order` - Whether to display the form or link strategies first. Accepted values are `:forms_first` or `:links_first`.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.Components.SignIn","ref":"AshAuthentication.Phoenix.Components.SignIn.html#module-overrides"},{"type":"module","doc":"* `otp_app` - The otp app to look for authenticated resources in\n  * `live_action` - The live_action being routed to\n  * `path` - The path to use as the base for links\n  * `reset_path` - The path to use for reset links\n  * `register_path` - The path to use for register links\n  * `overrides` - A list of override modules.\n  * `gettext_fn` - Optional text translation function.","title":"Props - AshAuthentication.Phoenix.Components.SignIn","ref":"AshAuthentication.Phoenix.Components.SignIn.html#module-props"},{"type":"type","doc":"","title":"AshAuthentication.Phoenix.Components.SignIn.props/0","ref":"AshAuthentication.Phoenix.Components.SignIn.html#t:props/0"},{"type":"module","doc":"A generic, white-label confirmation page.\n\nThis is used when `require_interaction?` is set to `true` on a confirmation strategy.","title":"AshAuthentication.Phoenix.ConfirmLive","ref":"AshAuthentication.Phoenix.ConfirmLive.html"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:root_class` - CSS class for the root `div` element.\n  * `:confirm_id` - Element ID for the `Reset` LiveComponent.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.ConfirmLive","ref":"AshAuthentication.Phoenix.ConfirmLive.html#module-overrides"},{"type":"module","doc":"Behaviour for overriding component styles and attributes in your application.\n\nThe default implementation is `AshAuthentication.Phoenix.Overrides.Default`\nwhich uses [TailwindCSS](https://tailwindcss.com/) to generate a fairly\ngeneric looking user interface.\n\nYou can override this by adding your own override modules to the\n`AshAuthentication.Phoenix.Router.sign_in_route/1` macro in your router:\n\n```elixir\nsign_in_route overrides: [MyAppWeb.AuthOverrides, AshAuthentication.Phoenix.Overrides.Default]\n```\n\nand defining `lib/my_app_web/auth_overrides.ex` within which you can set any\noverrides.\n\nThe `use` macro defines overridable versions of all callbacks which return\n`nil`, so you only need to define the functions that you care about.\n\nEach of the override modules specified in the config will be called in the\norder that they're specified, so you can still use the defaults if you just\noverride some properties.\n\n```elixir\ndefmodule MyAppWeb.AuthOverrides do\n  use AshAuthentication.Phoenix.Overrides\n  alias AshAuthentication.Phoenix.Components\n\n  override Components.Banner do\n    set :image_url, \"/images/sign_in_logo.png\"\n  end\nend\n```","title":"AshAuthentication.Phoenix.Overrides","ref":"AshAuthentication.Phoenix.Overrides.html"},{"type":"macro","doc":"Define overrides for a specific component.","title":"AshAuthentication.Phoenix.Overrides.override/2","ref":"AshAuthentication.Phoenix.Overrides.html#override/2"},{"type":"macro","doc":"Override a setting within a component.","title":"AshAuthentication.Phoenix.Overrides.set/2","ref":"AshAuthentication.Phoenix.Overrides.html#set/2"},{"type":"module","doc":"This is the default overrides for our component UI.\n\nThe CSS styles are based on [TailwindCSS](https://tailwindcss.com/).","title":"AshAuthentication.Phoenix.Overrides.Default","ref":"AshAuthentication.Phoenix.Overrides.Default.html"},{"type":"function","doc":"","title":"AshAuthentication.Phoenix.Overrides.Default.overrides/0","ref":"AshAuthentication.Phoenix.Overrides.Default.html#overrides/0"},{"type":"module","doc":"Override introspection.","title":"AshAuthentication.Phoenix.Overrides.Info","ref":"AshAuthentication.Phoenix.Overrides.Info.html"},{"type":"function","doc":"Returns a map of all known overridable modules and their overrides.","title":"AshAuthentication.Phoenix.Overrides.Info.all_overridable_modules/0","ref":"AshAuthentication.Phoenix.Overrides.Info.html#all_overridable_modules/0"},{"type":"behaviour","doc":"Auto generates documentation and helpers for components.","title":"AshAuthentication.Phoenix.Overrides.Overridable","ref":"AshAuthentication.Phoenix.Overrides.Overridable.html"},{"type":"macro","doc":"Retrieve configuration for a potentially overriden value.","title":"AshAuthentication.Phoenix.Overrides.Overridable.override_for/3","ref":"AshAuthentication.Phoenix.Overrides.Overridable.html#override_for/3"},{"type":"module","doc":"A generic, white-label password reset page.\n\nThis live-view can be rendered into your app using the\n`AshAuthentication.Phoenix.Router.reset_route/1` macro in your router (or by\nusing `Phoenix.LiveView.Controller.live_render/3` directly in your markup).\n\nThis live-view looks for the `token` URL parameter, and if found passes it to\n`AshAuthentication.Phoenix.Components.Reset`.","title":"AshAuthentication.Phoenix.ResetLive","ref":"AshAuthentication.Phoenix.ResetLive.html"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:root_class` - CSS class for the root `div` element.\n  * `:reset_id` - Element ID for the `Reset` LiveComponent.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.ResetLive","ref":"AshAuthentication.Phoenix.ResetLive.html#module-overrides"},{"type":"module","doc":"A generic, white-label sign-in page.\n\nThis live-view can be rendered into your app using the\n`AshAuthentication.Phoenix.Router.sign_in_route/1` macro in your router (or by\nusing `Phoenix.LiveView.Controller.live_render/3` directly in your markup).\n\nThis live-view finds all Ash resources with an authentication configuration\n(via `AshAuthentication.authenticated_resources/1`) and renders the\nappropriate UI for their providers using\n`AshAuthentication.Phoenix.Components.SignIn`.","title":"AshAuthentication.Phoenix.SignInLive","ref":"AshAuthentication.Phoenix.SignInLive.html"},{"type":"module","doc":"This component provides the following overrides:\n\n  * `:root_class` - CSS class for the root `div` element.\n  * `:sign_in_id` - Element ID for the `SignIn` LiveComponent.\n\n\nSee `AshAuthentication.Phoenix.Overrides` for more information.","title":"Overrides - AshAuthentication.Phoenix.SignInLive","ref":"AshAuthentication.Phoenix.SignInLive.html#module-overrides"},{"type":"module","doc":"Utility functions for sending and receiving flash messages.","title":"AshAuthentication.Phoenix.Utils.Flash","ref":"AshAuthentication.Phoenix.Utils.Flash.html"},{"type":"function","doc":"Attach a hook to receive flash messages sent from components, for rendering in\nthe top-level liveview.","title":"AshAuthentication.Phoenix.Utils.Flash.on_mount/4","ref":"AshAuthentication.Phoenix.Utils.Flash.html#on_mount/4"},{"type":"function","doc":"Send flash messages from components, to be rendered in their parent liveview.","title":"AshAuthentication.Phoenix.Utils.Flash.put_flash!/3","ref":"AshAuthentication.Phoenix.Utils.Flash.html#put_flash!/3"},{"type":"extras","doc":"![Logo](https://github.com/ash-project/ash/blob/main/logos/cropped-for-header-black-text.png?raw=true#gh-light-mode-only)\n![Logo](https://github.com/ash-project/ash/blob/main/logos/cropped-for-header-white-text.png?raw=true#gh-dark-mode-only)\n\n![Elixir CI](https://github.com/team-alembic/ash_authentication_phoenix/workflows/Elixir%20Library/badge.svg)\n[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)\n[![Hex version badge](https://img.shields.io/hexpm/v/ash_authentication_phoenix.svg)](https://hex.pm/packages/ash_authentication_phoenix)\n[![Hexdocs badge](https://img.shields.io/badge/docs-hexdocs-purple)](https://hexdocs.pm/ash_authentication_phoenix)\n\n# Ash Authentication Phoenix\n\nWelcome! Here you will find everything you need to know to get started with Ash Authentication and Phoenix. This documentation is best viewed on [hexdocs](https://hexdocs.pm/ash_authentication_phoenix)","title":"README","ref":"readme.html"},{"type":"extras","doc":"[**Tutorials**](#tutorials) walk you through a series of steps to accomplish a goal. These are **learning-oriented**, and are a great place for beginners to start.\n\n---\n\n[**Topics**](#topics) provide a high level overview of a specific concept or feature. These are **understanding-oriented**, and are perfect for discovering design patterns, features, and tools related to a given topic.\n\n---\n\n[**How-to**](#how-to) guides are **goal-oriented** recipes for accomplishing specific tasks. These are also good to browse to get an idea of how Ash Authentication works and what is possible with it.\n\n---\n\n[**Reference**](#reference) documentation is produced automatically from our source code. It comes in the form of module documentation and DSL documentation. This documentation is **information-oriented**. Use the sidebar and the search bar to find relevant reference information.","title":"About the Documentation - README","ref":"readme.html#about-the-documentation"},{"type":"extras","doc":"- [Get Started](documentation/tutorials/get-started.md)\n- [Using with LiveView](documentation/tutorials/liveview.md)\n- [Overriding UI](documentation/tutorials/ui-overrides.md)","title":"Tutorials - README","ref":"readme.html#tutorials"},{"type":"extras","doc":"- [Ash Framework](https://hexdocs.pm/ash)\n- [Ash Authentication](https://hexdocs.pm/ash_authentication)\n\n---\n\n[![Alembic](logos/alembic.png)](https://alembic.com.au)\n\nProudly written and maintained by the team at [Alembic](https://alembic.com.au) for the Ash community.","title":"Related packages - README","ref":"readme.html#related-packages"},{"type":"extras","doc":"# Getting Started Ash Authentication Phoenix\n\n<!-- tabs-open -->","title":"Get Started","ref":"get-started.html"},{"type":"extras","doc":"This will also install `ash_authentication` if you haven't run that installer.\n\n```sh\nmix igniter.install ash_authentication_phoenix\n```\n\nIf you'd like to see only the changes that `ash_authentication_phoenix` makes, you can run:\n\n```sh\nmix igniter.install ash_authentication\n# and then run\nmix igniter.install ash_authentication_phoenix\n```\n\nSee the [AshAuthentication getting started guide](https://hexdocs.pm/ash_authentication/get-started.html) for information\non how to add strategies and configure `AshAuthentication` if you have not already.","title":"With Igniter - Get Started","ref":"get-started.html#with-igniter"},{"type":"extras","doc":"#### Router Setup\n\n`ash_authentication_phoenix` includes several helper macros which can generate\nPhoenix routes for you. For that you need to add 6 lines in the router module or just replace the whole file with the following code:\n\n**lib/example_web/router.ex**\n\n```elixir\ndefmodule ExampleWeb.Router do\n  use ExampleWeb, :router\n\n  use AshAuthentication.Phoenix.Router # <-------- Add this line\n\n  pipeline :browser do\n    plug :accepts, [\"html\"]\n    plug :fetch_session\n    plug :fetch_live_flash\n    plug :put_root_layout, {ExampleWeb.Layouts, :root}\n    plug :protect_from_forgery\n    plug :put_secure_browser_headers\n    plug :load_from_session # <-------- Add this line\n  end\n\n  pipeline :api do\n    plug :accepts, [\"json\"]\n    plug :load_from_bearer # <--------- Add this line\n  end\n\n  scope \"/\", ExampleWeb do\n    pipe_through :browser\n\n    get \"/\", PageController, :home\n\n    # add these lines -->\n\n    # Standard controller-backed routes\n    auth_routes AuthController, Example.Accounts.User, path: \"/auth\"\n    sign_out_route AuthController\n\n    # Prebuilt LiveViews for signing in, registration, resetting, etc.\n    # Leave out `register_path` and `reset_path` if you don't want to support\n    # user registration and/or password resets respectively.\n    sign_in_route(register_path: \"/register\", reset_path: \"/reset\", auth_routes_prefix: \"/auth\")\n    reset_route [auth_routes_prefix: \"/auth\"]\n\n    # <-- add these lines\n  end\n\n  ...\nend\n```\n\n#### AuthController\n\nWhile running `mix phx.routes` you probably saw the warning message that the `ExampleWeb.AuthController.init/1 is undefined`. Let's fix that by creating a new controller:\n\n**lib/example_web/controllers/auth_controller.ex**\n\n```elixir\ndefmodule ExampleWeb.AuthController do\n  use ExampleWeb, :controller\n  use AshAuthentication.Phoenix.Controller\n\n  def success(conn, _activity, user, _token) do\n    return_to = get_session(conn, :return_to) || ~p\"/\"\n\n    conn\n    |> delete_session(:return_to)\n    |> store_in_session(user)\n    # If your resource has a different name, update the assign name here (i.e :current_admin)\n    |> assign(:current_user, user)\n    |> redirect(to: return_to)\n  end\n\n  def failure(conn, _activity, _reason) do\n    conn\n    |> put_flash(:error, \"Incorrect email or password\")\n    |> redirect(to: ~p\"/sign-in\")\n  end\n\n  def sign_out(conn, _params) do\n    return_to = get_session(conn, :return_to) || ~p\"/\"\n\n    conn\n    |> clear_session()\n    |> redirect(to: return_to)\n  end\nend\n```\n\nNote that `failure` will not necessarily ever be called. For example, `Components.Password.SignInForm` will handle\nfailures internally as long as `sign_in_tokens_enabled?` is true (which is the default).\n\n<!-- tabs-close -->","title":"Manual - Get Started","ref":"get-started.html#manual"},{"type":"extras","doc":"Given the above configuration you should see the following in your routes:\n\n```\n# mix phx.routes\n\nGenerated example app\n          auth_path  GET  /sign-in                               AshAuthentication.Phoenix.SignInLive :sign_in\n          auth_path  GET  /sign-out                              ExampleWeb.AuthController :sign_out\n          auth_path  *    /auth/user/password/register           ExampleWeb.AuthController {:user, :password, :register}\n          auth_path  *    /auth/user/password/sign_in            ExampleWeb.AuthController {:user, :password, :sign_in}\n          page_path  GET  /                                      ExampleWeb.PageController :home\n...\n```","title":"Generated routes - Get Started","ref":"get-started.html#generated-routes"},{"type":"extras","doc":"If you're integrating AshAuthentication into an existing app, you probably already have existing HTML layouts you want to use, to wrap the provided sign in/forgot password/etc. forms.\n\nLiveviews provided by AshAuthentication.Phoenix will use the same root layout configured in your router's `:browser` pipeline, but it includes its own layout file primarily for rendering flash messages.\n\nIf you would like to use your own layout file instead, you can specify this as an option to the route helpers, eg.\n\n```elixir\nreset_route(layout: {MyAppWeb, :live}, auth_routes_prefix: \"/auth\")\n```","title":"Customizing the generated routes - Get Started","ref":"get-started.html#customizing-the-generated-routes"},{"type":"extras","doc":"If you plan on using our default [Tailwind](https://tailwindcss.com/)-based\ncomponents without overriding them you will need to modify your\n`assets/tailwind.config.js` to include the `ash_authentication_phoenix`\ndependency:\n\n**assets/tailwind.config.js**\n\n```javascript\n// See the Tailwind configuration guide for advanced usage\n// https://tailwindcss.com/docs/configuration\n\nconst plugin = require(\"tailwindcss/plugin\");\n\nmodule.exports = {\n  content: [\n    \"./js/**/*.js\",\n    \"../lib/*_web.ex\",\n    \"../lib/*_web/**/*.*ex\",\n    \"../deps/ash_authentication_phoenix/**/*.*ex\", // <-- Add this line\n  ],\n  theme: {\n    extend: {\n      colors: {\n        brand: \"#FD4F00\",\n      },\n    },\n  },\n  plugins: [\n    require(\"@tailwindcss/forms\"),\n    plugin(({ addVariant }) =>\n      addVariant(\"phx-no-feedback\", [\n        \".phx-no-feedback&\",\n        \".phx-no-feedback &\",\n      ]),\n    ),\n    plugin(({ addVariant }) =>\n      addVariant(\"phx-click-loading\", [\n        \".phx-click-loading&\",\n        \".phx-click-loading &\",\n      ]),\n    ),\n    plugin(({ addVariant }) =>\n      addVariant(\"phx-submit-loading\", [\n        \".phx-submit-loading&\",\n        \".phx-submit-loading &\",\n      ]),\n    ),\n    plugin(({ addVariant }) =>\n      addVariant(\"phx-change-loading\", [\n        \".phx-change-loading&\",\n        \".phx-change-loading &\",\n      ]),\n    ),\n  ],\n};\n```","title":"Tailwind - Get Started","ref":"get-started.html#tailwind"},{"type":"extras","doc":"If you've just created your application, you can replace the default Phoenix `home.html.eex` with a minimal example which has a top navbar.\nOn the right side it shows the `@current_user` and a sign out button. If you are not signed in you will see a sign in button.\n\n**lib/example_web/controllers/page_html/home.html.heex**\n\n```html\n \n   \n     \n       \n         \n           \n             \n              Ash Demo\n             \n           \n         \n       \n       \n        <%= if @current_user do %>\n         \n          <%= @current_user.email %>\n         \n         \n          Sign out\n         \n        <% else %>\n         \n          Sign In\n         \n        <% end %>\n       \n     \n   \n \n\n \n   \n     \n       \n        Demo\n       \n     \n   \n   \n     \n       \n          \n       \n     \n   \n \n```","title":"Example home.html.heex - Get Started","ref":"get-started.html#example-home-html-heex"},{"type":"extras","doc":"If you are using LiveView, jump over to the [Use AshAuthentication with LiveView](/documentation/tutorials/liveview.md)\nsection and set up your LiveView routes for `AshAuthentication`. Once that is done, you can proceed with the following steps.","title":"If you are using LiveView - Get Started","ref":"get-started.html#if-you-are-using-liveview"},{"type":"extras","doc":"By default, no strategies are included. See the [getting started guide](https://hexdocs.pm/ash_authentication/get-started.html) in\n`AshAuthentication` for more on setting up individual authentication strategies.","title":"Configure strategies - Get Started","ref":"get-started.html#configure-strategies"},{"type":"extras","doc":"You can now start Phoenix and visit\n[`localhost:4000`](http://localhost:4000) from your browser.\n\n```bash\n$ mix phx.server\n```","title":"Start Phoenix - Get Started","ref":"get-started.html#start-phoenix"},{"type":"extras","doc":"Visit [`localhost:4000/sign-in`](http://localhost:4000/sign-in) from your browser.\n\nThe sign in page shows a link to register a new account.","title":"Sign In - Get Started","ref":"get-started.html#sign-in"},{"type":"extras","doc":"Visit [`localhost:4000/sign-out`](http://localhost:4000/sign-out) from your browser.","title":"Sign Out - Get Started","ref":"get-started.html#sign-out"},{"type":"extras","doc":"The default authentication view shows a generic error message to users if their sign-in fails, like \"Email or password was incorrect\". This is for security purposes - you don't want potentially malicious people to know if an email address definitively exists in your system.\n\nHowever, if you're having issues setting up AshAuthentication, or trying to debug issues with your implementation, that error message isn't super useful to figure out what's going wrong.\n\nTo that end, AshAuthentication comes with debug functionality that can be enabled in dev:\n\n**config/dev.exs**\n\n```elixir\nconfig :ash_authentication, debug_authentication_failures?: true\n```\n\n> #### Don't enable debugging outside `dev` environments! {: .warning}\n>\n> This could leak users' personally-identifiable information (PII) into your logs on failed sign-in attempts - a security issue!\n\nOnce the config is added, you can restart your dev server and test what happens when you visit the sign-in page and submit invalid credentials. You should see log messages like -\n\n```text\n[timestamp] [warning] Authentication failed: Query returned no users\n\nDetails: %AshAuthentication.Errors.AuthenticationFailed{\n  field: nil,\n  strategy: %AshAuthentication.Strategy.Password{\n    confirmation_required?: true,\n    ...\n```","title":"Debugging the Authentication flow - Get Started","ref":"get-started.html#debugging-the-authentication-flow"},{"type":"extras","doc":"In this section we add a reset password functionality. Which is triggered by adding `resettable` in the `User` resource. Please replace the `strategies` block in `lib/example/accounts/user.ex` with the following code:\n\n**lib/example/accounts/user.ex**\n\n```elixir\n# [...]\nstrategies do\n  password :password do\n    identity_field :email\n\n    resettable do\n      sender Example.Accounts.User.Senders.SendPasswordResetEmail\n    end\n  end\nend\n# [...]\n```\n\nTo make this work we need to create a new module `Example.Accounts.User.Senders.SendPasswordResetEmail`:\n\n**lib/example/accounts/user/senders/send_password_reset_email.ex**\n\n```elixir\ndefmodule Example.Accounts.User.Senders.SendPasswordResetEmail do\n  @moduledoc \"\"\"\n  Sends a password reset email\n  \"\"\"\n  use AshAuthentication.Sender\n  use ExampleWeb, :verified_routes\n\n  @impl AshAuthentication.Sender\n  def send(user, token, _) do\n    Example.Accounts.Emails.deliver_reset_password_instructions(\n      user,\n      url(~p\"/password-reset/#{token}\")\n    )\n  end\nend\n```\n\nWe also need to create a new email template:\n\n**lib/example/accounts/emails.ex**\n\n```elixir\ndefmodule Example.Accounts.Emails do\n  @moduledoc \"\"\"\n  Delivers emails.\n  \"\"\"\n\n  import Swoosh.Email\n\n  def deliver_reset_password_instructions(user, url) do\n    if !url do\n      raise \"Cannot deliver reset instructions without a url\"\n    end\n\n    deliver(user.email, \"Reset Your Password\", \"\"\"\n     \n       \n        Hi #{user.email},\n       \n\n       \n         Click here  to reset your password.\n       \n\n       \n        If you didn't request this change, please ignore this.\n       \n     \n    \"\"\")\n  end\n\n  # For simplicity, this module simply logs messages to the terminal.\n  # You should replace it by a proper email or notification tool, such as:\n  #\n  #   * Swoosh - https://hexdocs.pm/swoosh\n  #   * Bamboo - https://hexdocs.pm/bamboo\n  #\n  defp deliver(to, subject, body) do\n    IO.puts(\"Sending email to #{to} with subject #{subject} and body #{body}\")\n\n    new()\n    |> from({\"Zach\", \"zach@ash-hq.org\"}) # TODO: Replace with your email\n    |> to(to_string(to))\n    |> subject(subject)\n    |> put_provider_option(:track_links, \"None\")\n    |> html_body(body)\n    |> Example.Mailer.deliver!()\n  end\nend\n```\n\nYour new reset password functionality is active. Visit [`localhost:4000/sign-in`](http://localhost:4000/sign-in) with your browser and click on the `Forgot your password?` link to trigger the reset password workflow.","title":"Reset Password - Get Started","ref":"get-started.html#reset-password"},{"type":"extras","doc":"# Setting up your routes for LiveView\n\nA built in live session wrapper is provided that will set the user assigns for you. To use it, wrap your live routes like so:\n\n```elixir\nash_authentication_live_session :session_name do\n  live \"/route\", ProjectLive.Index, :index\nend\n```\n\nThere are two problems with the above, however.\n\n1. If there is no user present, it will not set `current_user: nil`.\n2. You may want a way to require that a user is present for some routes, and not for others.","title":"LiveView Routes","ref":"liveview.html"},{"type":"extras","doc":"To accomplish this, we use standard Phoenix [`on_mount` hooks](https://hexdocs.pm/phoenix_live_view/Phoenix.LiveView.html#on_mount/1-examples). Lets define a hook that gives us three potential behaviors, one for optionally having a user signed in, one for requiring a signed in user, and one for requiring that there is no signed in user.\n\n\n```elixir\n# lib/my_app_web/live_user_auth.ex\ndefmodule MyAppWeb.LiveUserAuth do\n  @moduledoc \"\"\"\n  Helpers for authenticating users in LiveViews.\n  \"\"\"\n\n  import Phoenix.Component\n  use MyAppWeb, :verified_routes\n\n  def on_mount(:live_user_optional, _params, _session, socket) do\n    if socket.assigns[:current_user] do\n      {:cont, socket}\n    else\n      {:cont, assign(socket, :current_user, nil)}\n    end\n  end\n\n  def on_mount(:live_user_required, _params, _session, socket) do\n    if socket.assigns[:current_user] do\n      {:cont, socket}\n    else\n      {:halt, Phoenix.LiveView.redirect(socket, to: ~p\"/sign-in\")}\n    end\n  end\n\n  def on_mount(:live_no_user, _params, _session, socket) do\n    if socket.assigns[:current_user] do\n      {:halt, Phoenix.LiveView.redirect(socket, to: ~p\"/\")}\n    else\n      {:cont, assign(socket, :current_user, nil)}\n    end\n  end\nend\n```\n\nAnd we can use this as follows:\n\n```elixir\n# lib/my_app_web/router.ex\n  # ...\n  scope \"/\", MyAppWeb do\n    # ...\n    ash_authentication_live_session :authentication_required,\n      on_mount: {MyAppWeb.LiveUserAuth, :live_user_required} do\n      live \"/protected_route\", ProjectLive.Index, :index\n    end\n\n    ash_authentication_live_session :authentication_optional,\n      on_mount: {MyAppWeb.LiveUserAuth, :live_user_optional} do\n      live \"/\", ProjectLive.Index, :index\n    end\n  end\n  # ...\n```\n\nYou can also use this to prevent users from visiting the auto generated `sign_in` route:\n\n```elixir\nsign_in_route(on_mount: [{MyAppWeb.LiveUserAuth, :live_no_user}])\n```","title":"Authentication helper - LiveView Routes","ref":"liveview.html#authentication-helper"},{"type":"extras","doc":"# Overriding Ash Authentication Phoenix's default UI\n\nAsh Authentication Phoenix provides a default UI implementation to get you started, however we wanted there to be a middle road between \"you gets what you gets\" and \"¯\\\\_(ツ)_/¯ make your own\". Thus AAP's system of UI overrides were born.\n\nEach of our LiveView components has a number of hooks where you can override either the CSS styles, text or images.\n\nIn addition you have the option to provide a `gettext/2` compatible function through which all output text will be run.","title":"UI Overrides","ref":"ui-overrides.html"},{"type":"extras","doc":"You override these components by defining an \"overrides module\", which you will then provide in your router when setting up your routes.\n\nFor example, if we wanted to change the default banner used on the sign-in page:\n\n```elixir\ndefmodule MyAppWeb.AuthOverrides do\n  use AshAuthentication.Phoenix.Overrides\n\n  # Override a property per component\n  override AshAuthentication.Phoenix.Components.Banner do\n    # include any number of properties you want to override\n    set :image_url, \"/images/rickroll.gif\"\n    set :dark_image_url, \"/images/rickroll-dark.gif\"\n  end\nend\n```\n\nYou only need to define the overrides you want to change. Unspecified overrides will use their default value.\n\nWhen overriding UI elements, remember to account for dark mode support. Some properties have dark mode variants (prefixed with `dark_`) that should be set alongside their light mode counterparts. For instance, if you override `image_url`, you should typically also set `dark_image_url` to ensure your UI looks good in both light and dark modes.","title":"Defining Overrides - UI Overrides","ref":"ui-overrides.html#defining-overrides"},{"type":"extras","doc":"Plug in your Gettext backend and have all display text translated automagically, see next section for an example.\n\nThe package includes Gettext templates for the untranslated messages and a growing number of translations. You might want to\n\n```sh\ncp -rv deps/ash_authentication_phoenix/i18n/gettext/* priv/gettext\n```\n\nFor other i18n libraries you have the option to provide a gettext-like handler function, see `AshAuthentication.Phoenix.Router.sign_in_route/1` for details.","title":"Internationalisation - UI Overrides","ref":"ui-overrides.html#internationalisation"},{"type":"extras","doc":"To do this, you modify your `sign_in_route` calls to contain the `overrides` option. Be sure to put the\n`AshAuthentication.Phoenix.Overrides.Default` override last, as it contains the default values for all components!\n\nThe same way you may add a `gettext_backend` option to specify your Gettext backend and domain.\n\n```elixir\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n  use AshAuthentication.Phoenix.Router\n\n  # ...\n\n  scope \"/\", MyAppWeb do\n    sign_in_route overrides: [MyAppWeb.AuthOverrides, AshAuthentication.Phoenix.Overrides.Default],\n                  gettext_backend: {MyAppWeb.Gettext, \"auth\"}\n  end\nend\n```","title":"Telling AshAuthentication about your overrides - UI Overrides","ref":"ui-overrides.html#telling-ashauthentication-about-your-overrides"},{"type":"extras","doc":"The below documentation is autogenerated from the components that support overrides.\nAll available overrides are listed here. If you are looking to override something not in this\nlist, please open an issue, or even better a PR!\n\nLooking at the source of the components can be enlightening to see exactly how an override is used.\nIf you click on the name of component you are interested in, and then look in the top right (if you are on hexdocs),\nyou will see a `</>` button that will take you to the source for that component. In that code, look for\ncalls to `override_for/3` to see specifically how each override is used.\n\n<!-- override-docs-begin -->","title":"Reference - UI Overrides","ref":"ui-overrides.html#reference"},{"type":"extras","doc":"### `AshAuthentication.Phoenix.SignInLive`\n\nA generic, white-label sign-in page.\n\n  * `:root_class` - CSS class for the root `div` element.\n\n  * `:sign_in_id` - Element ID for the `SignIn` LiveComponent.\n\n\n### `AshAuthentication.Phoenix.Components.SignIn`\n\nRenders sign in mark-up for an authenticated resource.\n\n  * `:authentication_error_container_class` - CSS class for the container for the text of the authentication error.\n\n  * `:authentication_error_text_class` - CSS class for the authentication error text.\n\n  * `:root_class` - CSS class for the root `div` element.\n\n  * `:show_banner` - Whether or not to show the banner.\n\n  * `:strategy_class` - CSS class for a `div` surrounding each strategy component.\n\n  * `:strategy_display_order` - Whether to display the form or link strategies first. Accepted values are `:forms_first` or `:links_first`.","title":"Sign In - UI Overrides","ref":"ui-overrides.html#sign-in"},{"type":"extras","doc":"### `AshAuthentication.Phoenix.Components.Password`\n\nGenerates sign in, registration and reset forms for a resource.\n\n  * `:hide_class` - CSS class to apply to hide an element.\n\n  * `:interstitial_class` - CSS class for the `div` element between the form and the button.\n\n  * `:register_toggle_text` - Toggle text to display when the register form is not showing (or `nil` to disable).\n\n  * `:reset_toggle_text` - Toggle text to display when the reset form is not showing (or `nil` to disable).\n\n  * `:root_class` - CSS class for the root `div` element.\n\n  * `:show_first` - The form to show on first load.  Either `:sign_in` or `:register`. Only relevant if paths aren't set for them in the router.\n\n  * `:sign_in_toggle_text` - Toggle text to display when the sign in form is not showing (or `nil` to disable).\n\n  * `:slot_class` - CSS class for the `div` surrounding the slot.\n\n  * `:toggler_class` - CSS class for the toggler `a` element.\n\n\n### `AshAuthentication.Phoenix.Components.Password.RegisterForm`\n\nGenerates a default registration form.\n\n  * `:button_text` - Text for the submit button.\n\n  * `:disable_button_text` - Text for the submit button when the request is happening.\n\n  * `:form_class` - CSS class for the `form` element.\n\n  * `:label_class` - CSS class for the `h2` element.\n\n  * `:root_class` - CSS class for the root `div` element.\n\n  * `:slot_class` - CSS class for the `div` surrounding the slot.\n\n\n### `AshAuthentication.Phoenix.Components.Password.SignInForm`\n\nGenerates a default sign in form.\n\n  * `:button_text` - Text for the submit button.\n\n  * `:disable_button_text` - Text for the submit button when the request is happening.\n\n  * `:form_class` - CSS class for the `form` element.\n\n  * `:label_class` - CSS class for the `h2` element.\n\n  * `:root_class` - CSS class for the root `div` element.\n\n  * `:slot_class` - CSS class for the `div` surrounding the slot.","title":"Password Sign-in - UI Overrides","ref":"ui-overrides.html#password-sign-in"},{"type":"extras","doc":"### `AshAuthentication.Phoenix.ConfirmLive`\n\nA generic, white-label confirmation page.\n\n  * `:confirm_id` - Element ID for the `Reset` LiveComponent.\n\n  * `:root_class` - CSS class for the root `div` element.\n\n\n### `AshAuthentication.Phoenix.Components.Confirm`\n\nRenders a confirmation button.\n\n  * `:root_class` - CSS class for the root `div` element.\n\n  * `:show_banner` - Whether or not to show the banner.\n\n  * `:strategy_class` - CSS class for a `div` surrounding each strategy component.\n\n\n### `AshAuthentication.Phoenix.Components.Confirm.Form`\n\nGenerates a default confirmation form.\n\n  * `:disable_button_text` - Text for the submit button when the request is happening.\n\n  * `:form_class` - CSS class for the `form` element.\n\n  * `:label_class` - CSS class for the `h2` element.\n\n  * `:root_class` - CSS class for the root `div` element.\n\n\n### `AshAuthentication.Phoenix.Components.Confirm.Input`\n\nFunction components for dealing with form input during password\nauthentication.\n\n  * `:submit_class` - CSS class for the form submit `input` element.\n\n  * `:submit_label` - A function that takes the strategy and returns text for the confirm button, or a string.","title":"Confirmation - UI Overrides","ref":"ui-overrides.html#confirmation"},{"type":"extras","doc":"### `AshAuthentication.Phoenix.ResetLive`\n\nA generic, white-label password reset page.\n\n  * `:reset_id` - Element ID for the `Reset` LiveComponent.\n\n  * `:root_class` - CSS class for the root `div` element.\n\n\n### `AshAuthentication.Phoenix.Components.Reset`\n\nRenders a password-reset form.\n\n  * `:root_class` - CSS class for the root `div` element.\n\n  * `:show_banner` - Whether or not to show the banner.\n\n  * `:strategy_class` - CSS class for a `div` surrounding each strategy component.\n\n\n### `AshAuthentication.Phoenix.Components.Reset.Form`\n\nGenerates a default password reset form.\n\n  * `:disable_button_text` - Text for the submit button when the request is happening.\n\n  * `:form_class` - CSS class for the `form` element.\n\n  * `:label_class` - CSS class for the `h2` element.\n\n  * `:root_class` - CSS class for the root `div` element.\n\n  * `:spacer_class` - CSS classes for space between the password input and submit elements.\n\n\n### `AshAuthentication.Phoenix.Components.Password.ResetForm`\n\nGenerates a default password reset form.\n\n  * `:button_text` - Tex for the submit button.\n\n  * `:disable_button_text` - Text for the submit button when the request is happening.\n\n  * `:form_class` - CSS class for the `form` element.\n\n  * `:label_class` - CSS class for the `h2` element.\n\n  * `:reset_flash_text` - Text for the flash message when a request is received.  Set to `nil` to disable.\n\n  * `:root_class` - CSS class for the root `div` element.\n\n  * `:slot_class` - CSS class for the `div` surrounding the slot.","title":"Password Reset - UI Overrides","ref":"ui-overrides.html#password-reset"},{"type":"extras","doc":"### `AshAuthentication.Phoenix.Components.Password.Input`\n\nFunction components for dealing with form input during password\nauthentication.\n\n  * `:error_li` - CSS class for the `li` elements on error lists.\n\n  * `:error_ul` - CSS class for the `ul` element on error lists.\n\n  * `:field_class` - CSS class for `div` elements surrounding the fields.\n\n  * `:identity_input_label` - Label for identity field.\n\n  * `:identity_input_placeholder` - Placeholder for identity field.\n\n  * `:input_class` - CSS class for text/password `input` elements.\n\n  * `:input_class_with_error` - CSS class for text/password `input` elements when there is a validation error.\n\n  * `:input_debounce` - Number of milliseconds to debounce input by (or `nil` to disable).\n\n  * `:label_class` - CSS class for `label` elements.\n\n  * `:password_confirmation_input_label` - Label for password confirmation field.\n\n  * `:password_input_label` - Label for password field.\n\n  * `:submit_class` - CSS class for the form submit `input` element.","title":"Password - UI Overrides","ref":"ui-overrides.html#password"},{"type":"extras","doc":"### `AshAuthentication.Phoenix.Components.MagicLink`\n\nGenerates a sign-in for for a resource using the \"Magic link\" strategy.\n\n  * `:disable_button_text` - Text for the submit button when the request is happening.\n\n  * `:form_class` - CSS class for the `form` element.\n\n  * `:label_class` - CSS class for the `h2` element.\n\n  * `:request_flash_text` - Text for the flash message when a request is received.  Set to `nil` to disable.\n\n  * `:root_class` - CSS class for the root `div` element.","title":"Magic Link - UI Overrides","ref":"ui-overrides.html#magic-link"},{"type":"extras","doc":"### `AshAuthentication.Phoenix.Components.Apple`\n\nGenerates a sign-in button for Apple.\n\n  * `:icon_class` - CSS classes for the icon SVG.\n\n  * `:link_class` - CSS classes for the `a` element.\n\n  * `:root_class` - CSS classes for the root `div` element.\n\n\n### `AshAuthentication.Phoenix.Components.OAuth2`\n\nGenerates a sign-in button for OAuth2.\n\n  * `:icon_class` - CSS classes for the icon SVG.\n\n  * `:link_class` - CSS classes for the `a` element.\n\n  * `:root_class` - CSS classes for the root `div` element.","title":"OAuth2 - UI Overrides","ref":"ui-overrides.html#oauth2"},{"type":"extras","doc":"### `AshAuthentication.Phoenix.Components.HorizontalRule`\n\nA horizontal rule with text.\n\n  * `:hr_inner_class` - CSS class for the inner `div` element of the horizontal rule.\n\n  * `:hr_outer_class` - CSS class for the outer `div` element of the horizontal rule.\n\n  * `:root_class` - CSS class for the root `div` element.\n\n  * `:text` - Text to display in front of the horizontal rule.\n\n  * `:text_inner_class` - CSS class for the inner `div` element of the text area.\n\n  * `:text_outer_class` - CSS class for the outer `div` element of the text area.\n\n\n### `AshAuthentication.Phoenix.Components.Banner`\n\nRenders a very simple banner at the top of the sign-in component.\n\n  * `:dark_image_class` - Css class for the `img` tag in dark mode.\n\n  * `:dark_image_url` - A URL for the `img` `src` attribute in dark mode. Set to `nil` to disable.\n\n  * `:href_class` - CSS class for the `a` tag.\n\n  * `:href_url` - A URL for the banner image to link to. Set to `nil` to disable.\n\n  * `:image_class` - CSS class for the `img` tag.\n\n  * `:image_url` - A URL for the `img` `src` attribute. Set to `nil` to disable.\n\n  * `:root_class` - CSS class for the root `div` element.\n\n  * `:text` - Banner text. Set to `nil` to disable.\n\n  * `:text_class` - CSS class for the text `div`.\n\n\n\n<!-- override-docs-end -->","title":"Miscellaneous - UI Overrides","ref":"ui-overrides.html#miscellaneous"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}